<template>
  <el-form :model="songForm" ref="songForm" :rules="rules">
    <div class="row">
      <div class="col-md-6">
        <el-form-item label="Name of a Song" prop="name">
          <el-input v-model="songForm.name"></el-input>
        </el-form-item>
      </div>
      <div class="col-md-6">
        <el-form-item label="Category" prop="category">
          <el-select
              v-model="songForm.category_id"
              multiple
              filterable
              placeholder="Choose categories for your song"
              class="w-100">
            <el-option
                v-for="item in categories"
                :key="item.id"
                :label="item.name"
                :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
      </div>
    </div>
    <el-form-item
        v-for="(part, index) in songForm.parts"
        :label="'Part ' + index"
        :key="index"
        :prop="'parts.' + index + '.value'"
        :rules="{required: true, message: 'Part can not be null', trigger: 'blur'}">
      <el-input type="textarea" rows="4" v-model="part.value"></el-input>
      <el-button v-show="songForm.parts.length > 1" @click.prevent="removePart(part)">Delete</el-button>
    </el-form-item>
    <el-form-item>
      <el-button v-if="!isEditing" type="primary" @click="submitForm('songForm')">Submit</el-button>
      <el-button @click="addPart">New part</el-button>
    </el-form-item>
    <el-form-item v-if="isEditing">
      <el-button type="warning" @click="submitForm('songForm')">Submit</el-button>
      <el-button type="danger" @click="deleteSong(song_id)">Delete Song</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
    import Requester from "@/controllers/requests/song.js";
    import RequesterCategory from "@/controllers/requests/category.js";

    const requester = new Requester();
    const requesterCategory = new RequesterCategory();
    export default {
        name: "SongEditor",
        data() {
            return {
                label: '',
                songForm: {
                    name: '',
                    parts: [{
                        value: ''
                    }],
                    category_id: [],
                },
                song_id: Number,
                song: {
                    name: '',
                    content: '',
                    category_id: [],
                },
                rules: {
                    name: [
                        {required: true, message: 'Please input Song name', trigger: 'blur'},
                        {min: 3, max: 255, message: 'Length should be 3 to 30', trigger: 'blur'}
                    ]
                },
                isEditing: false,
                categories: [],
            }
        },
        created() {
            const song = this.$route.params.song;
            if (song) {
                this.isEditing = true;
                this.song_id = song.id;
                this.fillSongForm(song);
            }
            this.getAllCategories();
        },
        methods: {
            submitForm(form) {
                this.song.name = this.songForm.name;
                this.songForm.parts.forEach((item) => {
                    this.song.content += `<p>${item.value}</p>`
                });
                this.song.category_id = this.songForm.category_id;
                this.$refs[form].validate((valid) => {
                    if (valid) {
                        if (this.isEditing) {
                            requester.putUpdateSong(this.song, this.songForm.id).then(() => {
                                this.$notify.success({
                                    title: 'Success',
                                    message: 'Song was successfully updated.'
                                });
                                return true;
                            }).catch(err => {
                                this.$notify.error({
                                    title: 'Error',
                                    message: err
                                });
                            })
                        } else {
                            requester.postNewSong(this.song).then(() => {
                                this.$notify.success({
                                    title: 'Success',
                                    message: 'Song was successfully saved.'
                                });
                                return true;
                            }).catch(err => {
                                this.$notify.error({
                                    title: 'Error',
                                    message: err
                                });
                            })
                        }

                    } else {
                        console.log('error submit!!');
                        return false;
                    }
                });
            },
            removePart(item) {
                let index = this.songForm.parts.indexOf(item);
                if (index !== -1) {
                    this.songForm.parts.splice(index, 1);
                }
            },
            addPart() {
                this.songForm.parts.push({
                    value: ''
                });
            },
            fillSongForm(song) {
                this.songForm.id = song.id;
                this.songForm.parts.pop();
                this.songForm.name = song.name;
                this.songForm.category_id = song.category_id;
                for (let item of song.content.match(/<p>.*?<\/p>/g)) {
                    let div = document.createElement("div");
                    div.innerHTML = item;
                    item = div.textContent || div.innerText || "";

                    this.songForm.parts.push({
                        value: item
                    })
                }
            },
            deleteSong(id) {
                this.$confirm('This will permanently delete the song. Continue?', 'Warning', {
                    confirmButtonText: 'Delete',
                    cancelButtonText: 'Cancel',
                    type: 'error'
                }).then(() => {
                    requester.deleteSong(id).then(() => {
                        this.$notify.success({
                            title: 'Success',
                            message: 'Song was deleted.'
                        });
                        this.$router.push({name: 'home'});
                        return true;
                    }).catch(err => {
                        this.$notify.error({
                            title: 'Error',
                            message: err
                        });
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: 'Delete canceled'
                    });
                });
            },
            getAllCategories() {
                requesterCategory.getAllCategories().then(res => {
                    this.categories = res;
                })
            }
        }
    }
</script>

<style scoped>

</style>
